.area _CODE

.include "bala.h.s"
.include "hero.h.s"
.include "cpctelera.h.s"
.globl health_counter_call
.globl _sprite_cartucho

bala_draw::

	ld	a, bala_status_off(ix)  		;Comprueba si la bala esta activa
	cp 	#0
	ret	z		

 	;; Obtener el puntero en pantalla
    call 	get_screen_pointer
    ex 		de, hl
    ld		c, bala_x_pos_off(ix)            	;; C=Obsx
    ld		b, bala_y_pos_off(ix)               ;; B=Obsy
    call 	cpct_getScreenPtr_asm

    ex de, hl ;;intercambiar los valores
   
    ;; Selecciona el ancho de la bala
    ld c, #0x04									;; C=ancho
    ld b, #0x04									;; D=alto

    ;; Selecciona el sprite
    ld hl, #_sprite_cartucho

	call cpct_drawSpriteMasked_asm

ret

;;===============================
;; Bala_update
;; INPUT:  -
;; DESTROY: A
;;==============================

bala_update::
	ld	a, bala_status_off(ix)  		;Comprueba si la bala esta activa
	cp 	#1
	ret	nz			

		ld 	a, bala_sentido_off(ix)			;; 1 = mirando a la izquierda, 2= mirando a la derecha
			cp 	#1
		jr z, mirando_izquierda
		
	;=================================================
		;; MOVE ->
		malo_mira_derecha::
		ld 	a, bala_x_pos_off(ix)			;; 1 = mirando a la izquierda, 2= mirando a la derecha
		inc a
		inc a
		cp #80-4 							;; Compara si ha llegado al final del mapa
		jr z, fin_destuye_bala				;; Si ha llegado llama a una funcion que destruye la bala	
				
				;; !=FIN && ->
				ld l, a
				call bala_comparar_moviendose
					ld a, bala_contador_velocidad_off(ix)
					cp #0
					jp nz, no_actualiza_update
				ld bala_x_pos_off(ix), l
				jr end_bala_update

	;===================================================
		;; MOVE <-
		mirando_izquierda:
		malo_mira_izquierda::

		ld 	a, bala_x_pos_off(ix)			;; 1 = mirando a la izquierda, 2= mirando a la derecha
		dec a
		dec a
		cp #0 								;; Compara si ha llegado al final del mapa
		jr z, fin_destuye_bala				;; Si ha llegado llama a una funcion que destruye la bala	
			;; !=FIN && <-
				ld l, a
				call bala_comparar_moviendose
					ld a, bala_contador_velocidad_off(ix)
					cp #0
					jp nz, no_actualiza_update
				ld bala_x_pos_off(ix), l
				jr end_bala_update

	;===================================================
		end_bala_update:
		ld bala_redraw_content_off(ix), #2

		ld a, bala_velocidad_off(ix)
		ld bala_contador_velocidad_off(ix), a

		ret

	no_actualiza_update:
	ld a, bala_contador_velocidad_off(ix)
	dec a
	ld bala_contador_velocidad_off(ix), a
ret


;;===============================
;; Comparar con la derecha
;; DESTROY: -
;; INPUT:  B (X_obj_1), C (Y_obj_1)
;; DESTROY: B, C
;;==============================

fin_destuye_bala::
	ld bala_status_off(ix), #0 			
    ld bala_redraw_content_off(ix), #2
ret

;;===============================
;; Comparar con la derecha
;; DESTROY: -
;; INPUT:  B (X_obj_1), C (Y_obj_1)
;; DESTROY: B, C
;; ;;===============================

bala_comparar_moviendose::
	ld	a, bala_status_off(ix)  		;Comprueba si la bala esta activa
	cp 	#0
	ret	z		
;; ============== X ================

	;; BULLETX + BULLETW - OBJX > 0    -->> COLLISION 
	ld 	a, bala_x_pos_off(ix)			;; A=BULLETX
	add #4 								;; A+=BULLETW
	sub b 								;; A-=OBJX
	jp z, no_colisiona_al_comparar
	jp m, no_colisiona_al_comparar

	;; OBJX + OBJW - BULLET > 0			<<-- COLLISION 
	ld 	  a, b							;; A=OBJX
	add   #8							;; A+=OBJW
	ld 	  b, bala_x_pos_off(ix) 		;; B =BULLETX
	sub   b 							;; A-=B
	jp z, no_colisiona_al_comparar
	jp m, no_colisiona_al_comparar

;; ============== Y ================
	;; BULLETY + BULLETH - OBJY > 0     vv-- COLLISION
	ld a, bala_y_pos_off(ix)		   ;; A=BULLETY
	add #4							   ;; A+=BULLETH
	sub c 							   ;; A-=OBJY
	jp z, no_colisiona_al_comparar
	jp m, no_colisiona_al_comparar

	;; OBJY + OBJW - BULLETY > 0       ^^-- COLLISION
	ld a, c 						   ;; A=OBJY
	add #32 					       ;; A+=OBJY
	ld c, bala_y_pos_off(ix)		   ;; C=BULLETY
	sub c 							   ;; A-=BULLETY
	jp z, no_colisiona_al_comparar
	jp m, no_colisiona_al_comparar

	;; SI HA LLEGADO ES QUE HA COLISIONADO
	push ix
	call hero_getPtrIX
	ld a, player_life_off(ix)
    dec a
    ld player_life_off(ix), a
    call health_counter_call
	pop ix
	call fin_destuye_bala		

	;;NO HA COLISIONADO
	no_colisiona_al_comparar:
ret

;;===============================
;; Actualiza los valores de las posiciones
;; 
;;===============================

update_draw_values:

	;; Cambia el valor del ultimo valor porque ya lo ha dibujado
	ld a, bala_posxant_off(ix)
	ld bala_posx2ant_off(ix), a
	ld a, bala_posyant_off(ix)
	ld bala_posy2ant_off(ix), a

	ld a, bala_x_pos_off(ix)
	ld bala_posxant_off(ix), a
	ld a, bala_y_pos_off(ix)
	ld bala_posyant_off(ix), a

ret

;;===============================
;; Erases the Hero
;; DESTROY: AF, BC, HL
;;===============================
bala_erase::

	ld	a, bala_redraw_content_off(ix) 		;Comprueba si la bala esta activa
	cp 	#0
	ret	z	

	;; 	Carga en x e y las posiciones a redibujar
    ld a, bala_posx2ant_off(ix)
   	ld c,a
    ld a, bala_posy2ant_off(ix)
    ld b,a

    ld d, #2 ; alto 
    ld e, #2 ; ancho 

;=============Compruba para dibujar el ancho==============

	ld a, c
	and #1 					;;Compara si es par o impar la posicion en x
	jr z, par

	;;Posicion Impar
	inc e   ;;Esto esta bien

	par:
		ld a, c
		and #3 					;;Comprueba si es el pixel 1,3 o 3 de ese tiled
		jr z, no_primera_y
		inc d

		no_primera_y:

;===Calcula la posicion en y =================
    srl b 		;;Divide entre 2 y luego entre otros 2
    srl b    

;===Calcula la posicion en x =================

    srl c

	ld hl, #_g_tileset                  ;;HAY QUE PONERLE EL SUBRAYADO PORQUE ES DE C
    call cpct_etm_setTileset2x4_asm

    ld hl, #_level1 ;;El mapa a leer
    push hl
    call get_screen_pointer
    push hl


    ld a, #40      ;;Ancho del mapa
    call cpct_etm_drawTileBox2x4_asm

    call update_draw_values

    ld a, bala_redraw_content_off(ix)
    dec a
    ld bala_redraw_content_off(ix), a

ret

;;===============================
;; Set bullet actived
;; DESTROY: -
;; INPUT: A(Sentido), D(Posicion_x), E(Posicion_y)
;; DESTROY: H
;;===============================
bala_activar::

	ld a, bala_redraw_content_off(ix)
	cp #0
	ret nz

	ld a, bala_status_off(ix)
	cp #1
	ret z

 	ld a, #1
 	ld bala_status_off(ix), a 			;;Pone la bala en activo

 	call get_random_position_y

 	ld a, bala_sentido_off(ix)			;; 1 = mirando a la izquierda, 2= mirando a la derecha
 	cp #1
 	jr z, mirando_izquierda_activar 	;; == 1 -> Mirando a la izquierda

 	;==>		
	ld d, #0	
	jr asignar_valores

	;<==
	mirando_izquierda_activar:				
	ld d,  #76	 	

 	asignar_valores:
  	ld bala_x_pos_off(ix), 	  d 		;;Almacena el valor de la posicion de x
 	ld bala_y_pos_off(ix),    e 		;;Almacena el valor de la posicion de y
 	ld bala_posxant_off(ix),  d			;;Almacena el valor de la posicion de x 
 	ld bala_posyant_off(ix),  e			;;Almacena el valor de la posicion de y 
 	ld bala_posx2ant_off(ix), d         ;;Almacena el valor de la posicion de x 
 	ld bala_posy2ant_off(ix), e			;;Almacena el valor de la posicion de y

 	ld bala_redraw_content_off(ix), #2
ret


get_random_position_y::

;;Obtiene valor random
	ld l, #0  							;;Establece semilla
	call cpct_getRandom_lcg_u8_asm		;;Obtiene el valor

	ld a, l
	srl a
	add #40
	ld e, a 							;;Guarda el valor de la posicion de Y
	and #1 								;;Compara si es par o impar la posicion en x
	jr z, par_random
		;; Impar
	ld bala_sentido_off(ix), #1 			;;Guarda el sentido de la bala
	jr fin_random
		;;Par
	par_random:
 	ld bala_sentido_off(ix), #2 			;;Guarda el sentido de la bala
 	fin_random:

ret
