;;===============================================================================================================
;;===============================================================================================================
;; PUBLIC FUNCTIONS
;;===============================================================================================================
;;===============================================================================================================

.globl enemy_erase
.globl enemy_draw
.globl enemy_update

;;----------------------------------------------------
;; Definition of DATA structures and constants
;;----------------------------------------------------

;; Macro: struct Enemy
;; Macro that creates a new initialized instance of Enemy Struct
;;
.macro defineEnemy instanceName, px, py, wi, he, sprite, life, velocity, status, attack_cooldown, posxant, posyant, posx2ant, posy2ant, redrawcounter, retrocediendo, eje_y_retrocediendo, x_pos_inicial, y_pos_inicial, sprite_cont, sprite_status, sprite_status_idle, sprite_status_walk, status_looking, level, activo, follow_cont, id

   ;; Struct data
   instanceName:
      instanceName'_x_pos:  .db px     ;; X location of the Enemy (bytes)
      instanceName'_y_pos:  .db py     ;; Y location of the Enemy (pixels)
      instanceName'_width:  .db wi     ;; Width of the Enemy Sprite (bytes)
      instanceName'_height: .db he     ;; Height of the Enemy Sprite (bytes)
      instanceName'_sprite:  .dw sprite  ;; sprite
      instanceName'_life:  .db life 
      instanceName'_velocity:  .db velocity  ;; velocity
      instanceName'_status:  .db status  ;; 0 = NO ESTA EN ZONA DE ATAQUE, 1 = EN ZONA DE ATAQUE, puede atacar (y ser atacado) Enemy situado a la izquierda de Player, 2 = EN ZONA DE ATAQUE, puede atacar (y ser atacado) Enemy situado a la derecha de Player
     instanceName'_attack_cooldown:  .db attack_cooldown
     instanceName'_posxant:  .db posxant
     instanceName'_posyant:  .db posyant
     instanceName'_posx2ant:  .db posx2ant
     instanceName'_posy2ant:  .db posy2ant
     instanceName'_redrawcounter:  .db redrawcounter
     instanceName'_retrocediendo:  .db retrocediendo ; 0 = NO retrocediendo, >1 = SÍ retrocediendo, este valor se usa de contador
     instanceName'_eje_y_retrocediendo:  .db eje_y_retrocediendo ; 0 = mantiene eje Y, 1 = Sube (visualmente) el eje Y, 2 = baja (visualmente) el eje Y
     instanceName'_x_pos_inicial:  .db x_pos_inicial
     instanceName'_y_pos_inicial:  .db y_pos_inicial
     instanceName'_sprite_cont:  .db sprite_cont
     instanceName'_sprite_status:  .db sprite_status ; 0 = idle, 1 = attack, 2 = walk, 3 = pre attack
     instanceName'_sprite_status_idle:  .db sprite_status_idle ; 0 = base, 1 = idle
     instanceName'_sprite_status_walk:  .db sprite_status_walk  ; 0 = base, 1 = walk
     instanceName'_status_looking:  .db status_looking  ;; 1 = mirando a la izquierda, 2= mirando a la derecha
     instanceName'_level:  .db level  
     instanceName'_activo:  .db activo  ; 0 = no activo (no en gameplay), 1 = activo
     instanceName'_follow_cont:  .db follow_cont 
     instanceName'_id:  .db id ;  para diferenciar a los 4 enemigos 
.endm

enemy_x_pos_off  =  0 ;; X offset
enemy_y_pos_off =  1 ;; Y offset
enemy_width_off = 2 ;; Width offset
enemy_height_off = 3 ;; Height offset
enemy_sprite_off = 4 ;; Sprite offset
enemy_life_off = 6;; Velocity offset
enemy_velocity_off = 7;; Velocity offset
enemy_status_off = 8
enemy_cooldown_off = 9
enemy_posxant_off = 10
enemy_posyant_off = 11
enemy_posx2ant_off = 12
enemy_posy2ant_off = 13
enemy_redrawcounter_off = 14
enemy_retrocediendo_off = 15
enemy_eje_y_retrocediendo_off = 16
enemy_x_pos_inicial_off  =  17;; X offset
enemy_y_pos_inicial_off =  18 ;; Y offset
enemy_sprite_cont_off =  19 ;; Y offset
enemy_sprite_status_off =  20 ;; Y offset
enemy_sprite_status_idle_off =  21 ;; Y offset
enemy_sprite_status_walk_off =  22 ;; Y offset
enemy_status_looking_off =  23 ;; Y offset
enemy_level_off =  24
enemy_activo_off =  25
enemy_follow_cont_off =  26
enemy_id_off =  27
