.area _CODE
.include "cpctelera.h.s"
.include "hero.h.s"
.include "enemy.h.s"

.globl health_counter_call

;;===============================================================================================================
;;===============================================================================================================
;; PRIVATE FUNCTIONS
;;===============================================================================================================
;;===============================================================================================================


;;=============================================================================================
;; DIBUJAR
;; INPUTS: IX = player struct pointer, a = COLOR
;; DESTROY: AF, BC, DE, HL
;;=============================================================================================

enemy_draw::
	
	ld a, enemy_redrawcounter_off(ix)
	cp #0
	ret z ; si es cero sale de la funcion

        call drawEnemy							;;Draw our hero :)
        ld a, enemy_redrawcounter_off(ix)
        dec a
        ld enemy_redrawcounter_off(ix), a
ret

;;===============================
;; Gestiona sprites
;; 
;;===============================

gestor_sprites_enemy::

    ;;;; FIN VOLTEAR SPRITES

    ld a, enemy_sprite_cont_off(ix) ;; solo si el contador es 0 se cambia el sprite
    cp #0
    jp nz, no_nuevo_sprite 
    
        ;; Si es 0 se asigna nuevo sprite
        ld a, #2 ;; para que dibuje cuando cambia el sprite
        ld enemy_redrawcounter_off(ix), a
        
        ; Sprite PreAtacar
        ld a, enemy_sprite_status_off(ix)
        cp #3
        jp nz, no_PREatacando_gestor_sprites
            
            ld a, enemy_status_looking_off(ix)
            cp #1
            jp nz, no_PREatack_left_gestor_sprites
            
                ld hl, #_sprite_Enemy_PreAttack_Left
                ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld enemy_sprite_off + 0(ix), l   ;; |
            
                ld a, #0 ;; estado sprite idle
                ld enemy_sprite_status_off(ix), a
            
                ld a, #8 ; Updates que va a permanecer este sprite
                ld enemy_sprite_cont_off(ix), a
                
                jp finalizar_funcion_gestor_sprites
            
            no_PREatack_left_gestor_sprites:
            
                ld hl, #_sprite_Enemy_PreAttack
                ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld enemy_sprite_off + 0(ix), l   ;; |
            
                ld a, #0 ;; estado sprite idle
                ld enemy_sprite_status_off(ix), a
            
                ld a, #8 ; Updates que va a permanecer este sprite
                ld enemy_sprite_cont_off(ix), a
                
                jp finalizar_funcion_gestor_sprites
            
        no_PREatacando_gestor_sprites:

        ;; Sprite atacar
        ld a, enemy_sprite_status_off(ix)
        cp #1
        jp nz, no_atacando_gestor_sprites
        
            ld a, enemy_status_looking_off(ix)
            cp #1
            jp nz, no_atack_left_gestor_sprites
            
                ld hl, #_sprite_Enemy_Attack_Left
                ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld enemy_sprite_off + 0(ix), l   ;; |
            
                jp saltar_atack_right_gestor_sprites
                
            no_atack_left_gestor_sprites:
            
                ld hl, #_sprite_Enemy_Attack
                ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld enemy_sprite_off + 0(ix), l   ;; |
                
            saltar_atack_right_gestor_sprites:
            
            ld a, #0 ;; estado sprite idle
            ld enemy_sprite_status_off(ix), a
        
            ld a, #3 ; Updates que va a permanecer este sprite
            ld enemy_sprite_cont_off(ix), a
            
            jp finalizar_funcion_gestor_sprites
        
        no_atacando_gestor_sprites:
        
        ;; Sprite andar
        
        ld a, enemy_sprite_status_off(ix)
        cp #2
        jp nz, no_andando_gestor_sprites
            
            ld a, enemy_sprite_status_walk_off(ix)
            cp #1
            jp z, sprite_2_walk
                ;;sprite andar 1 (base)
                
                ld a, enemy_status_looking_off(ix)
                cp #1
                jp nz, no_walk_base_left_gestor_sprites
                
                    ld hl, #_sprite_Enemy_Base_Left
                    ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                    ld enemy_sprite_off + 0(ix), l   ;; |
                
                    jp saltar_walk_base_right_gestor_sprites
                    
                no_walk_base_left_gestor_sprites:
                
                    ld hl, #_sprite_Enemy_Base
                    ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                    ld enemy_sprite_off + 0(ix), l   ;; |
                
                saltar_walk_base_right_gestor_sprites:
                
                ld a, #1 ;; estado walk
                ld enemy_sprite_status_walk_off(ix), a
                
                ld a, #8 ; Updates que va a permanecer este sprite
                ld enemy_sprite_cont_off(ix), a
                
                jp finalizar_funcion_gestor_sprites

            ;;sprite andar 2 (walk)
            sprite_2_walk:
            
                ld a, enemy_status_looking_off(ix)
                cp #1
                jp nz, no_walk_walk_left_gestor_sprites
                
                    ld hl, #_sprite_Enemy_Walk_Left
                    ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                    ld enemy_sprite_off + 0(ix), l   ;; |
                
                    jp saltar_walk_walk_right_gestor_sprites
                    
                no_walk_walk_left_gestor_sprites:
                
                    ld hl, #_sprite_Enemy_Walk
                    ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                    ld enemy_sprite_off + 0(ix), l   ;; |
                
                saltar_walk_walk_right_gestor_sprites:
                
                ld a, #0 ;; estado walk
                ld enemy_sprite_status_walk_off(ix), a
        
                ld a, #8 ; Updates que va a permanecer este sprite
                ld enemy_sprite_cont_off(ix), a
                
                jp finalizar_funcion_gestor_sprites
        
        no_andando_gestor_sprites:
        
        ;;Sprite Base (sprite_status == 0)
        
        ld a, enemy_sprite_status_idle_off(ix)
        cp #1
        jp z, sprite_2_idle
            ;;sprite idle 1 (base)

            ld a, enemy_status_looking_off(ix)
            cp #1
            jp nz, no_base_left_gestor_sprites    
                
                ld hl, #_sprite_Enemy_Base_Left
                ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld enemy_sprite_off + 0(ix), l   ;; |
                
                ld a, #1 ;; estado idle
                ld enemy_sprite_status_idle_off(ix), a
                
                ld a, #16 ; Updates que va a permanecer este sprite
                ld enemy_sprite_cont_off(ix), a
                
                jp finalizar_funcion_gestor_sprites
            
            no_base_left_gestor_sprites:
            
                ld hl, #_sprite_Enemy_Base
                ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld enemy_sprite_off + 0(ix), l   ;; |
                
                ld a, #1 ;; estado idle
                ld enemy_sprite_status_idle_off(ix), a
                
                ld a, #16 ; Updates que va a permanecer este sprite
                ld enemy_sprite_cont_off(ix), a
                
                jp finalizar_funcion_gestor_sprites
            
        ;;sprite idle 2 (idle)
        sprite_2_idle:

        
            ld a, enemy_status_looking_off(ix)
            cp #1
            jp nz, no_idle_left_gestor_sprites    
            
                ld hl, #_sprite_Enemy_Idle_Left
                ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld enemy_sprite_off + 0(ix), l   ;; |
                
                ld a, #0 ;; estado idle
                ld enemy_sprite_status_idle_off(ix), a
        
                ld a, #16 ; Updates que va a permanecer este sprite
                ld enemy_sprite_cont_off(ix), a
                
                jp finalizar_funcion_gestor_sprites
                
                
            no_idle_left_gestor_sprites:
            
                ld hl, #_sprite_Enemy_Idle
                ld enemy_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld enemy_sprite_off + 0(ix), l   ;; |
                
                ld a, #0 ;; estado idle
                ld enemy_sprite_status_idle_off(ix), a
        
                ld a, #16 ; Updates que va a permanecer este sprite
                ld enemy_sprite_cont_off(ix), a
                
                jp finalizar_funcion_gestor_sprites
            
    no_nuevo_sprite: ;; por tanto se decrementa el contador
        dec a
        ld enemy_sprite_cont_off(ix), a
        
    
    finalizar_funcion_gestor_sprites:
    
ret

;;===============================
;; Actualiza los valores de las posiciones
;; 
;;===============================

update_draw_values:

	;; Cambia el valor del ultimo valor porque ya lo ha dibujado
	ld a, enemy_posxant_off(ix)
	ld enemy_posx2ant_off(ix), a
	ld a, enemy_posyant_off(ix)
	ld enemy_posy2ant_off(ix), a

	ld a, player_x_pos_off(ix)
	ld enemy_posxant_off(ix), a
	ld a, player_y_pos_off(ix)
	ld enemy_posyant_off(ix), a

ret

;;===============================
;; Erases the Hero
;; DESTROY: AF, BC, HL
;;===============================
enemy_erase::
	
	ld a, enemy_redrawcounter_off(ix)
	cp #0
	ret z

	;; 	Carga en x e y las posiciones a redibujar
    ld a, enemy_posx2ant_off(ix)
   	ld c,a
    ld a, enemy_posy2ant_off(ix)
    ld b,a

    ld d, #9 ; alto 
    ld e, #4 ; ancho 

;=============Compruba para dibujar el ancho==============

	ld a, c
	and #1 					;;Compara si es par o impar la posicion en x
	jr z, par

	;;Posicion Impar
	inc e

	par:
		ld a, c
		and #3 					;;Comprueba si es el pixel 1,3 o 3 de ese tiled
		jr z, no_primera_y
		inc d

		no_primera_y:

;===Calcula la posicion en y =================
    srl b 		;;Divide entre 2 y luego entre otros 2
    srl b    


;===Calcula la posicion en x =================

    srl c

	ld hl, #_g_tileset                  ;;HAY QUE PONERLE EL SUBRAYADO PORQUE ES DE C
    call cpct_etm_setTileset2x4_asm

    ld hl, #_level1 ;;El mapa a leer
    push hl
    call get_screen_pointer
    push hl

    ld a, #40      ;;Ancho del mapa
    call cpct_etm_drawTileBox2x4_asm

    call update_draw_values

ret

;;=============================================================================================
;; Funcion de segumiento a Player
;; INPUTS: IX puntero Enemy, HL puntero Player
;; RETURN:
;;=============================================================================================
	
enemy_followPlayer:

;; Calibracion Movimiento horizontal para que el enemigo no solape con el player
;; Solo ocurre en el caso de que (enemy_x + enemy_width >= player_x AND enemy_x <= player_x + player_width)
;; PRIMERA COMPROBACION del AND
call hero_getPtrHL
ld a, enemy_x_pos_off(ix) ;; enemy_x
ld c, a
ld a, enemy_width_off(ix) ;; enemy_W
add c
ld c, (hl)
sub c               ;; A = A - C 
sub #2
jp m, no_cumple_AND_calibracion_horizontal
jp z, no_cumple_AND_calibracion_horizontal

ld a, enemy_id_off(ix)
cp #3
jp z, no_cumple_AND_calibracion_horizontal ; caso especial del enemy_3 y 4

ld a, enemy_id_off(ix)
cp #4
jp z, no_cumple_AND_calibracion_horizontal ; caso especial del enemy_3 y 4
    
    ;; SEGUNDA COMPROBACION del AND
    ld a, enemy_x_pos_off(ix) ;; enemy_x
    sub (hl) 
    inc hl
    inc hl
    sub (hl)
    add #2
    jp p, no_cumple_AND_calibracion_horizontal
    
        ;;SI CUMPLE AMBAS CONDICIONES
        
        ;; Ahora se comprueba si esta en la mitad izquierda o derecha del width del player
        ;; Si (enemy_x >= player_x + (player_width / 2)) --> Movimiento a la derecha, sino izquierda
        call hero_getPtrHL
        ld a, enemy_x_pos_off(ix) ;; enemy_x
        sub (hl) ;; (enemy_x - player_x)
        inc hl
        inc hl
        ld c, (hl) ;; player_width
        sra c ;; DIvision entre 2
        sub c
        jp m, no_movimiento_derecha_calibracion_horizontal
            
            ld a, enemy_x_pos_off(ix) ;; control limite derecho
            cp #80 - 8 ;(8 = width sprite/2)
            jp z, no_cumple_AND_calibracion_horizontal 
            
                inc a 			
                ld enemy_x_pos_off(ix), a
                
                ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve
                
                ld a, #2 ;; estado sprite walk
                ld enemy_sprite_status_off(ix), a
                
                jp no_mover_abajo;; Este salto se hace para no realizar nigngun movimiento mas en este update

       no_movimiento_derecha_calibracion_horizontal: ;; es decir, mover a la izquierda
        
            ld a, enemy_x_pos_off(ix) ;; control limite izquierdo
            cp #0
            jp z, no_cumple_AND_calibracion_horizontal 
        
                dec a 			
                ld enemy_x_pos_off(ix), a
                
                ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve
                
                ld a, #2 ;; estado sprite walk
                ld enemy_sprite_status_off(ix), a
                
            jp no_mover_abajo;; Este salto se hace para no realizar nigngun movimiento mas en este update
    
no_cumple_AND_calibracion_horizontal:


;; Empezamos a comprobar solo en el eje x
;; en ensamblador lo mejor es intentar comparar con 0 por eso se hace el calculo despejando
;;
;; player_x + player_w < enemy_x (pasar enemy al otro lado de la inecuacion)

;;======== MOVER IZQUIERDA

call hero_getPtrHL

    ld a, (hl) ;; hero_x
	ld c, a
	inc hl
	inc hl
	ld a, (hl) ;; hero_W
	add c 			;; Suma en A = A + C
    ld c, enemy_x_pos_off(ix)
    sub c               ;; A = A - C
    sub #2
    
	jp p, no_mover_izquierda
        
        ld a, enemy_x_pos_off(ix) ;; control limite izquierdo
        cp #0
        jp z, no_mover_abajo 
        
            dec a 				;x--
            ld enemy_x_pos_off(ix), a
            
            ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve
            
            ld a, #2 ;; estado sprite walk
            ld enemy_sprite_status_off(ix), a
        
        ld a, enemy_id_off(ix)
        cp #4 ; condicion enemigo 4
        jp z, condicion_follow_enemy4_1
        
            jp no_mover_abajo
            
        condicion_follow_enemy4_1:
        
	no_mover_izquierda:
	
;;======== MOVER DERECHA
call hero_getPtrHL
;; 
;; 
    ld a, enemy_x_pos_off(ix) ;; enemy_x
	ld c, a
	ld a, enemy_width_off(ix) ;; enemy_W
	add c 			;; Suma en A = A + C
    ld c, (hl)
    sub c               ;; A = A - C
    sub #2
	jp p, no_mover_derecha
        
        ld a, enemy_x_pos_off(ix) ;; control limite derecho
        cp #80 - 8 ;(8 = width sprite/2)
        jp z, no_mover_abajo 
        
            inc a 				;x++
            ld enemy_x_pos_off(ix), a
            
            ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve
            
            ld a, #2 ;; estado sprite walk
            ld enemy_sprite_status_off(ix), a
            
            ld a, enemy_id_off(ix)
            cp #4 ; condicion enemigo 4
            jp z, condicion_follow_enemy4_2
                jp no_mover_abajo
            condicion_follow_enemy4_2:
        
	no_mover_derecha:

;;====Movimientos verticales===

;;======== MOVER ARRIBA Y ABAJO

call hero_getPtrHL

;;if (enemy_y + enemy_h > hero_y + hero_h)
    	  
	ld a, enemy_y_pos_off(ix)
	ld c, a
	ld a, enemy_height_off(ix)    
	add c ;; enemy_y + enemy_height

	inc hl 
	sub (hl) ;; se resta hero_y al valor anterior
	
	inc hl
	inc hl
	sub (hl) ;; se resta hero_height al valor anterior
	
	jr z, no_mover_abajo 
	jp m, no_mover_arriba
        
        ld a, enemy_y_pos_off(ix)
        cp #16 ;(32 = heigth sprite)			;;Comprueba con el limite inferior
        jr z, no_mover_abajo 
        
            dec a
            dec a ;y--
            ld enemy_y_pos_off(ix), a
            
            ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve
        
        jr no_mover_abajo
	
	no_mover_arriba: ;; igual a mover abajo
	
        ld a, enemy_y_pos_off(ix)
        cp #200-48 ;(32 = heigth sprite)			;;Comprueba con el limite inferior
        jr z, no_mover_abajo 

            ;Control para que no se salga del mapa
            inc a 
            inc a ;y++
            ld enemy_y_pos_off(ix), a
            
            ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve

	no_mover_abajo: ;; esta etiqueta tambien se usa para saltarse el movimiento vertical una vez realizado el horizontal
	
ret

;;=============================================================================================
;; Funcion que comprueba si el enemigo esta a su derecha o izquierda
;; INPUTS: Enemigo en IX, el jugador lo obtiene con el hero_getPtrHL
;; RETURN: Varia el valor del status del enemigo
;;=============================================================================================
enemy_checkStatusLooking:
  
    ;; Ahora se comprueba si esta a la derecha o izquierda del Player
    ;; Si (enemy_x >= player_x + (player_width / 2)) --> Esta a la derecha del Player
    call hero_getPtrHL
    ld a, enemy_x_pos_off(ix) ;; enemy_x
    sub (hl) ;; (enemy_x - player_x)
    inc hl
    inc hl
    ld c, (hl) ;; player_width
    sra c ;; DIvision entre 2
    sub c
    jp m, situado_a_la_izquierda_enemy_checkStatusLooking
    
        ; Situado a la derecha ->mirar a la izquierda
        ld enemy_status_looking_off(ix), #1
        
        jp finalizar_funcion_checkStatusLooking
    
    situado_a_la_izquierda_enemy_checkStatusLooking:
        ld enemy_status_looking_off(ix), #2

    finalizar_funcion_checkStatusLooking:

ret


;;=============================================================================================
;; Funcion que comprueba si el enemigo esta lo suficentemente cerca como para atacar
;; INPUTS: Enemigo en IX, el jugador lo obtiene con el hero_getPtrHL
;; RETURN: Varia el valor del status del enemigo
;;=============================================================================================
	
enemy_checkDistancePlayer:
    
    ;; Puede atacar en el caso de que 
    ;;(enemy_y + 32 > player_y + 24 AND 
    ;; enemy_y + 32 < player_y + 40 AND 
    ;; enemy_x + 16 > player_x - 4 AND
    ;; enemy_x < player_x +20)

    ;; PRIMERA COMPROBACION del AND
    
    call hero_getPtrHL

    ld a, enemy_y_pos_off(ix) 
    ld c, a
    ld a, #32
    add a, c ; A = enemy_y + 32
    inc hl ;player_y
    ld c, (hl)
    sub c               ;; A = A - C 
        ld b, a ;; copio el valor para usarlo en el segundo AND
    ld c, #24
    sub c 
    add #12
    jp m, no_cumple_ANDS_checkDistancePlayer

        ;; SEGUNDA COMPROBACION del AND
        ld a, b
        ld c, #40
        sub c 
        sub #5
        jp p, no_cumple_ANDS_checkDistancePlayer
        
        
            ;; TERCERA COMPROBACION del AND
            ld a, enemy_x_pos_off(ix)
            dec hl ; player_x
            ld c, (hl)
            sub c 
                ld b, a ;; copio el valor para usarlo en el cuarto AND
            ld c, #9
            add c
            sub #3
            jp m, no_cumple_ANDS_checkDistancePlayer
            
                ;; CUARTA COMPROBACION del AND
                ld a, b
                ld c, #10
                sub c 
                add #3
                jp p, no_cumple_ANDS_checkDistancePlayer
                
                    ;; Todos los AND correctos
                    
                    ;; Ahora se comprueba si esta a la derecha o izquierda del Player
                    ;; Si (enemy_x >= player_x + (player_width / 2)) --> Esta a la derecha del Player
                    call hero_getPtrHL
                    ld a, enemy_x_pos_off(ix) ;; enemy_x
                    sub (hl) ;; (enemy_x - player_x)
                    inc hl
                    inc hl
                    ld c, (hl) ;; player_width
                    sra c ;; DIvision entre 2
                    sub c
                    jp m, situado_a_la_izquierda_checkDistancePlayer
                    
                        ; Situado a la derecha
                        ld enemy_status_off(ix), #2
                        
                        jp finalizar_funcion_checkDistancePlayer
                    
                    situado_a_la_izquierda_checkDistancePlayer:
                        ld enemy_status_off(ix), #1
 
                    jp finalizar_funcion_checkDistancePlayer
        
    no_cumple_ANDS_checkDistancePlayer:
    
        ld enemy_status_off(ix), #0
    
    finalizar_funcion_checkDistancePlayer:

ret

;;=============================================================================================
;; Funcion que realiza el ataque al Player cuando se acaba el cooldown
;; INPUTS: Enemigo en IX, el jugador lo obtiene con el hero_getPtrHL
;; RETURN: Varia el valor de  attack_cooldown del enemigo
;;=============================================================================================
	
enemy_attack:
   
    ld a, enemy_status_off(ix);; Contador se reinicia cuando el enemigo esta fuera de rango
    cp #0
    jp nz, finalizar_restart_attack_cooldown2
        ; INICIO RANDOM cooldown_attack
        ld l, #0
        call cpct_getRandom_lcg_u8_asm
        sra l
        sra l
        sra l
        sra l
        sra l
        ld a, l
        add a, #3 ; (para que quede en el rango [0, 7])
        add a, #3; (para que entre 2 ataque haya un minimo de tiempo)
        ld enemy_cooldown_off(ix), a
        ; FIN RANDOM cooldown_attack
        
    finalizar_restart_attack_cooldown2:
    
    ld a, enemy_status_off(ix);; El contador solo se varia cuando el enemigo esta en posicion de ataque (status 1 o 2), cuando esta 0 no varia
    cp #0
    jp z, finalizar_funcion_enemy_attack
    
        ld a, enemy_cooldown_off(ix) ;; Solo ataca cuando el cooldown llega a 0
        dec a 				
        jr	nz, no_restart_attack_cooldown
            
            ; INICIO RANDOM cooldown_attack
            ld l, #0
            call cpct_getRandom_lcg_u8_asm
            sra l
            sra l
            sra l
            sra l
            sra l
            ld a, l
            add a, #3 ; (para que quede en el rango [0, 7])
            add a, #3; (para que entre 2 ataque haya un minimo de tiempo)
            ld enemy_cooldown_off(ix), a
            ; FIN RANDOM cooldown_attack
            
            ld a, enemy_status_off(ix);; SOlo puede atacar si esta eb status 1 o 2
            cp #0
            jp z, finalizar_funcion_enemy_attack
                ;; Se le resta vida al player
                push ix
                call hero_getPtrIX
                ld b, player_life_off(ix)
                dec b
                ld player_life_off(ix), b
                call health_counter_call
                pop ix
                
                ld a, #1 ;; estado sprite atacar
                ld enemy_sprite_status_off(ix), a
                
                ld a, #0 ;; Esto fuerza a que comienza un nuevo sprite en caso de que hubiese uno con contador activo
                ld enemy_sprite_cont_off(ix), a
                
                jp finalizar_funcion_enemy_attack
            
        no_restart_attack_cooldown:
            ld enemy_cooldown_off(ix), a
            
            ld a, enemy_status_off(ix);; SOlo puede atacar si esta eb status 1 o 2
            cp #0
            jp z, finalizar_funcion_enemy_attack

                ld a, enemy_cooldown_off(ix);; pone el estado PREataque si el cooldown es 2
                cp #5
                jp p, finalizar_funcion_enemy_attack
                    ;; aqui entra solo si es 2 o menor
                    ld a, #3 ;; estado sprite PREatacar
                    ld enemy_sprite_status_off(ix), a
                    
                    ld a, #0 ;; Esto fuerza a que comienza un nuevo sprite en caso de que hubiese uno con contador activo
                    ld enemy_sprite_cont_off(ix), a
                
    finalizar_funcion_enemy_attack:
ret

;;=============================================================================================
;; Funcion que realiza el ataque al Player cuando se acaba el cooldown
;; INPUTS: Enemigo en IX
;; RETURN: Varia el valor de  attack_cooldown del enemigo
;;=============================================================================================
	
enemy_go_back:
    
    ld a, enemy_status_off(ix)
    cp #1
    jp z, enemigo_izquierda_go_back
    
    cp #2 
    jp z, enemigo_derecha_go_back
    
    cp #0  
    jp z, enemigo_mov_eje_y_go_back ;; cuando es 0, hacer movimiento vertical
    
        enemigo_izquierda_go_back:
        
            ld a, enemy_x_pos_off(ix) ;; control limite izquierdo
            cp #0
            jp z, finalizar_comprobaciones_go_back 
            
                dec a
                ld enemy_x_pos_off(ix), a
            
                ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve
                
                ld a, #2 ;; estado sprite walk
                ld enemy_sprite_status_off(ix), a
            
        jp finalizar_comprobaciones_go_back
        
        
        enemigo_derecha_go_back:
        
        
            ld a, enemy_x_pos_off(ix) ;; control limite derecho
            cp #80 - 8 ;(8 = width sprite/2)
            jp z, finalizar_comprobaciones_go_back 
        
                inc a
                ld enemy_x_pos_off(ix), a
            
                ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve
                
                ld a, #2 ;; estado sprite walk
                ld enemy_sprite_status_off(ix), a
            
        jp finalizar_comprobaciones_go_back
    
        enemigo_mov_eje_y_go_back:
            
            ld a, enemy_eje_y_retrocediendo_off(ix)
            cp #2  
            jp z, arriba_eje_y_retroceder
            cp #3 
            jp z, abajo_eje_y_retroceder
            
                jp finalizar_comprobaciones_go_back ;; si entra aqui esque es 0 o 1 en cuyo caso se mantiene en su eje vertical, por tanto no se hace nada
            
                arriba_eje_y_retroceder:
                
                    ld a, enemy_y_pos_off(ix) ;Comprueba con el limite superior
                    cp #16
                    jp z, finalizar_comprobaciones_go_back 
                
                        dec a
                        dec a
                        ld enemy_y_pos_off(ix), a
                    
                        ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve
                        
                        ld a, #2 ;; estado sprite walk
                        ld enemy_sprite_status_off(ix), a
                             
                jp finalizar_comprobaciones_go_back
                    
                abajo_eje_y_retroceder:
                    
                    ld a, enemy_y_pos_off(ix)
                    cp #200-48 ;(32 = heigth sprite)			;;Comprueba con el limite inferior
                    jp z, finalizar_comprobaciones_go_back 
                        
                        inc a
                        inc a
                        ld enemy_y_pos_off(ix), a
                    
                        ld enemy_redrawcounter_off(ix), #2 ;; para que dibuje cuando se mueve
                        
                        ld a, #2 ;; estado sprite walk
                        ld enemy_sprite_status_off(ix), a          
    
    finalizar_comprobaciones_go_back:
    
    ; Decrementar el contador 
    ld a, enemy_retrocediendo_off(ix)
    dec a 
    ld enemy_retrocediendo_off(ix), a

ret

;;===============================================================================================================
;;===============================================================================================================
;; PUBLIC FUNCTIONS
;;===============================================================================================================
;;===============================================================================================================


;;=============================================================================================
;; Update
; IN: ENEMY IN XI
;; DESTROY: AF, BC, HL, tambien destruye lo de las funciones que llama: enemy_followPlayer
;;=============================================================================================
enemy_update::

    ld a, enemy_velocity_off(ix)
	dec a 				
	jp	nz, no_restart_vel	
        
        ;; cuando el contador es mayor que 0, esta retrocediendo
        ld a, enemy_retrocediendo_off(ix)
        dec a 				
        jp	z, no_retrocede
        jp	m, no_retrocede
        
            ;; Si entra aqui, esta retrocediendo
            call enemy_go_back 
            
            jp saltar_follow_contRetrocediendo
        
        no_retrocede:
	
            ;; Seguir al player solo se realiza cuando NO esta retrocediendo
            
            ld a, enemy_follow_cont_off(ix)
            dec a 				
            jp	p, no_restart_follow_cont
            
                push ix
                call enemy_followPlayer
                pop ix
                
                ld l, #0
                call cpct_getRandom_lcg_u8_asm
                sra l
                sra l
                sra l
                sra l
                
                ld a, enemy_id_off(ix)				
                cp #1	
                jp nz, no_id_1_enemy_update
                    sra l
                    sra l
                    sra l
                no_id_1_enemy_update:
                
                ld a, enemy_id_off(ix)				
                cp #2	
                jp nz, no_id_2_enemy_update
                    
                    sra l
                    sra l
                no_id_2_enemy_update:
                
                ld a, enemy_id_off(ix)				
                cp #3	
                jp nz, no_id_3_enemy_update
                    sra l
                no_id_3_enemy_update:
                
                ld a, enemy_id_off(ix)				
                cp #4	
                jp nz, no_id_4_enemy_update
                    sra l
                    sra l
                    sra l
                no_id_4_enemy_update:
                
                ld a, l
            no_restart_follow_cont:
                ld enemy_follow_cont_off(ix), a
            
            ;; Al azar decide cuando retrocede (cuando el numero random == 0 -> inicia retroceso)
            ;; Solo lo hace cuando su estado es 1 o 2
            ld a, enemy_status_off(ix)
            cp #0 ;; si no es 0, su valor sera 1 o 2
            jp z, saltar_follow_contRetrocediendo
                
                ld l, #0
                call cpct_getRandom_lcg_u8_asm
                sra l
                sra l
                sra l
                sra l
                sra l
                ld a, l
                cp #0 ;(1/8 probabilidad de que salga 0)
                jr nz, saltar_follow_contRetrocediendo
                
                    ld enemy_retrocediendo_off(ix), #20 ;;contador retrocediendo, este contador solo sirve para el tiempo que esta en posicion retrasada, no sirve para aumentar la distancia (en el eje X) de retroceso
                    
                    ;Se elige al azar hacia donde se retrasa verticalmente
                    ld l, #0
                    call cpct_getRandom_lcg_u8_asm
                    sra l
                    sra l
                    sra l
                    sra l
                    sra l
                    sra l
                    ld a, l
                    add a, #2 ; (para tener rango [0,3])
                    ld enemy_eje_y_retrocediendo_off(ix), a
                     
            saltar_follow_contRetrocediendo: ;;Aqui entra siempre
                call enemy_attack
                call enemy_checkDistancePlayer
                call enemy_checkStatusLooking
                ld a, #8 ;; cada 8 updates del player, enemy hace 1
    
    no_restart_vel:
        ld enemy_velocity_off(ix), a
        
ret

;;=============================================================================================
;; Draws the enemy
;; DESTROY: AF, BC, HL
;;=============================================================================================
drawEnemy::

    ;;Calculate Screen Position
	;ld 	de, #CPCT_VMEM_START;; Video Memory Pointer
	ld c, enemy_x_pos_off(ix)				;; C=Obsx
	ld b, enemy_y_pos_off(ix) 				;; B=Obsy
	call cpct_getScreenPtr_asm

	;;	Draw a box
	ex de, hl ;;intercambiar los valores
	ld   h, enemy_sprite_off + 1(ix)   ;; | HL = Pointer to Player Sprite
    ld   l, enemy_sprite_off + 0(ix)   ;; |
	ld c, enemy_width_off(ix)
	ld b, enemy_height_off(ix)
	
	call cpct_drawSpriteMasked_asm

ret
