
.area _CODE

.include "hero.h.s"
.include "enemy.h.s"

;;===============================================================================================================
;;===============================================================================================================
;; PRIVATE DATA
;;===============================================================================================================
;;===============================================================================================================

player_cooldown_attack = 10
player_cooldown_attack_cont: .db #1	
	
hero_score:	.db #0x00	;(Decena y unidad) de la puntuacion
hero_score_sup:	.db #0x00	;Unidad de millar y centena de la puntuacion
hero_score_rondas:	.db #0x00	;Esta puntuacion se incrementa de forma normal con "inc"

get_player_score_rondas::
    ld a, (hero_score_rondas)
ret

max_score_sup: .db #0x00   ;Unidad de millar y centena de la puntuacion
max_score: .db #0x00   ;(Decena y unidad) de la puntuacion

text_counter: 	.db #2 ;; para redibujar en boble buffer la puntuacion
health_counter: .db #2

;; VARIABLES DOBLE BUFFER

posx2ant:	.db #50
posxant: 	.db #50

posy2ant:	.db #80
posyant:	.db #80

redrawcounter:	.db #2

;; FIN VARIABLES DOBLE BUFFER

sprite_cont: .db #0
sprite_status: .db #0 ; 0 = idle, 1 = attack, 2 = walk
    sprite_status_idle: .db #0 ; 0 = base, 1 = idle
    sprite_status_walk: .db #0 ; 0 = base, 1 = walk

end_game: .asciz "                          You died!      Press R to restart                     "

.include "cpctelera.h.s"
.include "keyboard/keyboard.s"
;;===============================================================================================================
;;===============================================================================================================
;; PUBLIC FUNCTIONS
;;===============================================================================================================
;;===============================================================================================================

reiniciar_puntuacion::

    ld a, (max_score_sup)
    ld b, a
    ld a, (hero_score_sup)
    sub b
    jp m, borra_puntuacion    

    ld a, (max_score)
    ld b, a
    ld a, (hero_score)
    sub b
    jp m, borra_puntuacion    

    ld a, (hero_score)
    ld (max_score), a

    ld a, (hero_score_sup)
    ld (max_score_sup), a

    borra_puntuacion:
        ld a, #0
        ld (hero_score), a
        ld (hero_score_sup), a
        ld a, #2
        ld (text_counter), a
        ld (health_counter), a
        
    ld a, #0
    ld (hero_score_rondas), a

ret


;;===============================
;; Updates the Hero
;; DESTROY: AF, BC, HL
;;===============================
player_update::
    	call CheckUserInput						;;Comprueba si le han dado alguna tecla
    	call gestor_sprites
ret

;;===============================
;; Draws the Hero
;; DESTROY: AF, BC, HL
;;===============================
player_draw::
	
	ld a, (redrawcounter)
	cp #0
	ret z ; si es cero sale de la funcion

        call drawPlayer 							;;Draw our hero :)
        ld a, (redrawcounter)
        dec a
        ld (redrawcounter), a
ret

;;===============================
;; Gestiona sprites
;; 
;;===============================

gestor_sprites:
    
    ;;;; INICIO VOLTEAR SPRITES
    ;; Se compara el status anterior con el actual
    ld a, player_status_off(ix)
    ld b, player_status_ant_off(ix)
    sub b
    jp z, no_flip_sprites
    
        ;; Se voltean todos los sprites
        
        ld hl, #_sprite_Player_Attack
        ld player_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
        ld player_sprite_off + 0(ix), l   ;; |
        call flip_sprite
        
        ld hl, #_sprite_Player_Base
        ld player_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
        ld player_sprite_off + 0(ix), l   ;; |
        call flip_sprite
        
        ld hl, #_sprite_Player_Idle
        ld player_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
        ld player_sprite_off + 0(ix), l   ;; |
        call flip_sprite
        
        ld hl, #_sprite_Player_Walk
        ld player_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
        ld player_sprite_off + 0(ix), l   ;; |
        call flip_sprite
        
        ld a, #0 ;; Esto fuerza a que comienza un nuevo sprite en caso de que hubiese uno con contador activo
        ld (sprite_cont), a
    
    no_flip_sprites:
    
    ;; Se guarda el status actual en anterior
    ld a, player_status_off(ix)
    ld player_status_ant_off(ix), a
    
    ;;;; FIN VOLTEAR SPRITES
    
    ld a, (sprite_cont) ;; solo si el contador es 0 se cambia el sprite
    cp #0
    jp nz, no_nuevo_sprite 
    
        ;; Si es 0 se asigna nuevo sprite
        ld a, #2 ;; para que dibuje cuando cambia el sprite
        ld (redrawcounter), a
        
        ;; Sprite atacar
        ld a, (sprite_status)
        cp #1
        jp nz, no_atacando_gestor_sprites
            
            ld hl, #_sprite_Player_Attack
            ld player_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
            ld player_sprite_off + 0(ix), l   ;; |
            
            ld a, #0 ;; estado sprite idle
            ld (sprite_status), a
        
            ld a, #4 ; Updates que va a permanecer este sprite
            ld (sprite_cont), a
            
            jp finalizar_funcion_gestor_sprites
        
        no_atacando_gestor_sprites:
        
        ;; Sprite andar
        
        ld a, (sprite_status)
        cp #2
        jp nz, no_andando_gestor_sprites
            
            ld a, (sprite_status_walk)
            cp #1
            jp z, sprite_2_walk
                ;;sprite andar 1 (base)
                
                ld hl, #_sprite_Player_Base
                ld player_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld player_sprite_off + 0(ix), l   ;; |
                
                ld a, #1 ;; estado walk
                ld (sprite_status_walk), a
                
                ld a, #4 ; Updates que va a permanecer este sprite
                ld (sprite_cont), a
                
                jp finalizar_funcion_gestor_sprites

            ;;sprite andar 2 (base)
            sprite_2_walk:
            
                ld hl, #_sprite_Player_Walk
                ld player_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
                ld player_sprite_off + 0(ix), l   ;; |
                
                ld a, #0 ;; estado walk
                ld (sprite_status_walk), a
        
                ld a, #4 ; Updates que va a permanecer este sprite
                ld (sprite_cont), a
                
                jp finalizar_funcion_gestor_sprites
        
        no_andando_gestor_sprites:
        
        ;;Sprite Base (sprite_status == 0)
        
        ld a, (sprite_status_idle)
        cp #1
        jp z, sprite_2_idle
            ;;sprite idle 1 (base)
            
            ld hl, #_sprite_Player_Base
            ld player_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
            ld player_sprite_off + 0(ix), l   ;; |
            
            ld a, #1 ;; estado idle
            ld (sprite_status_idle), a
            
            ld a, #10 ; Updates que va a permanecer este sprite
            ld (sprite_cont), a
            
            jp finalizar_funcion_gestor_sprites

        ;;sprite idle 2 (idle)
        sprite_2_idle:
        
            ld hl, #_sprite_Player_Idle
            ld player_sprite_off + 1(ix), h    ;; | HL = Pointer to Player Sprite
            ld player_sprite_off + 0(ix), l   ;; |
            
            ld a, #0 ;; estado idle
            ld (sprite_status_idle), a
    
            ld a, #10 ; Updates que va a permanecer este sprite
            ld (sprite_cont), a
            
            jp finalizar_funcion_gestor_sprites
    
    no_nuevo_sprite: ;; por tanto se decrementa el contador
        dec a
        ld (sprite_cont), a
        
    finalizar_funcion_gestor_sprites:
    
ret

;;===============================
;; Actualiza los valores de las posiciones
;; 
;;===============================

update_draw_values:

	;; Cambia el valor del ultimo valor porque ya lo ha dibujado
	ld a, (posxant)
	ld (posx2ant), a
	ld a, (posyant)
	ld (posy2ant), a

	ld a, player_x_pos_off(ix)
	ld (posxant), a
	ld a, player_y_pos_off(ix)
	ld (posyant), a

ret

;;========================
;; Flip sprite
;; DESTROY: A, DE, HL
;;========================

flip_sprite:

	ld 	a, 	#8		;;Ancho en bytes
	ld 	c,	a 		
	ld 	a,	#32 	;;Alto en pixeles
	ld 	b, 	a
	ld  h, 	player_sprite_off + 1(ix)   ;; | HL = Pointer to Player Sprite
    ld  l, 	player_sprite_off + 0(ix)   ;; |
	call cpct_hflipSpriteMaskedM0_asm

ret

;;===============================
;; Erases the Hero
;; DESTROY: AF, BC, HL
;;===============================
player_erase::
	
	ld a, (redrawcounter)
	cp #0
	ret z

	;; 	Carga en x e y las posiciones a redibujar
    ld a, (posx2ant)
   	ld c,a
    ld a, (posy2ant)
    ld b,a

    ld d, #9 ; alto (porque si)
    ld e, #4 ; ancho (porque si)

;=============Compruba para dibujar el ancho==============

	ld a, c
	and #1 					;;Compara si es par o impar la posicion en x
	jr z, par

	;;Posicion Impar
	inc e   ;;Esto esta bien

	par:
		ld a, c
		and #3 					;;Comprueba si es el pixel 1,3 o 3 de ese tiled
		jr z, no_primera_y
		inc d

		no_primera_y:

;===Calcula la posicion en y =================
    srl b 		;;Divide entre 2 y luego entre otros 2
    srl b    

;===Calcula la posicion en x =================

    srl c

	ld hl, #_g_tileset                  ;;HAY QUE PONERLE EL SUBRAYADO PORQUE ES DE C
    call cpct_etm_setTileset2x4_asm

    ld hl, #_level1 ;;El mapa a leer
    push hl
    call get_screen_pointer
    push hl

    ld a, #40      ;;Ancho del mapa
    call cpct_etm_drawTileBox2x4_asm

    call update_draw_values

ret

;;===============================
;; Draws the Hero's score
;; DESTROY: 
;;===============================
hero_draw_score::

	call drawScore
    call drawHealth
ret

;;===============================================================================================================
;;===============================================================================================================
;; PRIVATE FUNCTIONS
;;===============================================================================================================
;;===============================================================================================================


;;===============================
;; Mueve el heroe a la dereccha si no esta en el limite
;; DESTROY: AF
;;===============================

move_hero_right:
	  ;; D esta presionada

	  ld a, player_x_pos_off(ix)
	  cp #80 - 8 ;(8 = width sprite/2)					;;Comprueba con el limite derecho (El ancho de pantalla menos el tamaño del personaje)
	  jr z, fin_move 				;;Si hero_x==limite, pasa a la siguiente comprobacion

	      ;;Muevete a la derecha
	      move_right:
	      ld a, player_x_pos_off(ix)
	      inc a		
	      ld player_x_pos_off(ix), a

	      ld a, #2 ;; para que dibuje cuando se mueve
		  ld (redrawcounter), a
		  
		  ;; INICIO FLIP SPRITE
		  ld a, player_status_off(ix)		    ;;Mirar si tiene que cambiar de direccion el sprite
	      cp #2								;; Si es 2 esta a la derecha
	      jr z, fin_move
		  
		  ld player_status_off(ix), #2
		  
	  fin_move:

ret

;;===============================
;; Mueve el heroe a la izquierda si no esta en el limite
;; DESTROY: AF
;;===============================

move_hero_left:
	  ;;A esta presionada
	  ld a, player_x_pos_off(ix)
	  cp #0						;;Comprueba con el limite izquierdo
	  jp z, d_not_move_l 				;;Si hero_x==limite, pasa a la siguiente comprobacion

	      ;;Muevete a la derecha
	      move_left:
	      dec a
	      ld player_x_pos_off(ix), a
	      
		  ld a, #2
		  ld (redrawcounter), a
		  
		  ;; INICIO FLIP SPRITE
		  ld a, player_status_off(ix)		    ;;Mirar si tiene que cambiar de direccion el sprite
	      cp #1								;; Si es 2 esta a la derecha
	      jp z, fin_move

	      ;call flip_sprite
	      ;; FIN FLIP SPRITE
		  
		  ld player_status_off(ix), #1
		  															       
	  d_not_move_l:

ret

;;===============================
;; Mueve el heroe arriba si no esta en el limite
;; DESTROY: AF
;;===============================

move_hero_up:
	  ;;E esta presionada
	  ld a, player_y_pos_off(ix)
	  cp #16						
	  jr z, d_not_move_u 				;;Si hero_x==limite, pasa a la siguiente comprobacion

        ;;Muevete a la derecha
        move_up:
        dec a
        dec a
        ld player_y_pos_off(ix), a
        ld a, #2
        ld (redrawcounter), a
																		       
    d_not_move_u:
ret

;;===============================
;; Mueve el heroe abajo si no esta en el limite
;; DESTROY: AF
;;===============================

move_hero_down:

	  ;;S esta presionada
	  ld a, player_y_pos_off(ix)
	  cp #200-48 ;(32 = heigth sprite)			;;Comprueba con el limite inferior
	  jr z, d_not_move_d 				;;Si hero_x==limite, pasa a la siguiente comprobacion

        ;;Muevete a la derecha
        move_down:
        inc a
        inc a
        ld player_y_pos_off(ix), a
        ld a, #2
        ld (redrawcounter), a
																		       
    d_not_move_d:
ret
	
;;===============================
;; Ataque del player
;; INPUTS: NO HAY -> coge al enemy en IX y hero en ix salvando la pila
;; DESTROY: AF, BC, DE, HL
;;===============================	
player_attack:

    call enemy_getPtrIX
    
    ;; Si esta mirando a la izquierda (status del player = 1), realiza danyo a los enemigos con status = 1, lo mismo a la derecha con ambos status a 2
    
    bucle_enemies_atacar:
        ld a, (total_enemies_cont)
        dec a 				
        jp	m, restart_enemy_attack_cont
        
            ld a, enemy_status_off(ix)
            cp #0
            jp z, enemigo_lejos ;; enemigo fuera de rango
                
                ld a, enemy_status_off(ix)
                cp #1  ;; enemigo situado a la izquierda
                jp z, enemigo_izquierda
                
                cp #2  ;; enemigo situado a la izquierda
                jp z, enemigo_derecha
                
                jp enemigo_lejos ;; esto es para el caso en el que el estado del enemigo sea distinto de 1 y 2
                
                    enemigo_izquierda:
                    
                        ; Solo si el player esta mirando a la izquierda le hara danyo
                        push ix
                        call hero_getPtrIX 
                        ld a, player_status_off(ix)
                        cp #1
                        pop ix
                        jp nz, enemigo_lejos ;; enemigo fuera de rango
                        
                        
                            ;; En este punto el player resta vida al enemigo que tiene a su izquierda
                            ld a, enemy_life_off(ix)
                            dec a
                            ld enemy_life_off(ix), a
                        
                            ld a, #1
                            ld hl, #hero_score
                            call increase_score
                        
                            jp nz, enemigo_lejos 
                           
                    enemigo_derecha:
                    
                        ; Solo si el player esta mirando a la derecha le hara danyo
                        push ix
                        call hero_getPtrIX 
                        ld a, player_status_off(ix)
                        cp #2
                        pop ix
                        jp nz, enemigo_lejos ;; enemigo fuera de rango
                        
                            ;; En este punto el player resta vida al enemigo que tiene a su izquierda
                            ld a, enemy_life_off(ix)
                            dec a
                            ld enemy_life_off(ix), a
                            
                            ld a, #1
                            ld hl, #hero_score
                            call increase_score
                    
                    jp nz, enemigo_lejos 
                            
            enemigo_lejos:
            
            ld bc, #28
            add ix,bc ;;Puntero siguiente enemigo
            
            ld a, (total_enemies_cont)  ;; Actualizar contador
            dec a                       ;; Actualizar contador
            ld (total_enemies_cont), a  ;; Actualizar contador
            
            jp bucle_enemies_atacar
    restart_enemy_attack_cont:
        ld a, (total_enemies)
        ld (total_enemies_cont), a


    call hero_getPtrIX ;; para que las siguientes funciones cojan al player en IX

ret

;;===============================
;; Comprueba la entrada del usuario y reacciona
;; DESTROY: AF, BC, DE, HL
;;===============================

CheckUserInput:
	;;Escaneamos el teclado
	call cpct_scanKeyboard_asm 
	
    ld a, (player_cooldown_attack_cont) ;; Solo puede atacar cuando el cooldown llega a 0
    dec a 				
    jr	nz, player_no_puede_atacar
    
        ;;Comprueba si la tecla E esta pulsada ATACAR)
        ld hl, #Key_Space							;;Como es una constante pilla el valor de la letra A
        call cpct_isKeyPressed_asm
        cp  #0                            		;;Comprueba si a==0
        jr nz, comprobar_ataque						;;Este es el caso en el que el jugador puede atacar, pero no ha pulsado el boton de atacar
            
        ld hl, #Joy0_Fire1						
        call cpct_isKeyPressed_asm
        cp  #0                            	
        jr nz, comprobar_ataque	
        
        jp dejar_de_comprobar_ataque

            ;;SPACE pulsada
            comprobar_ataque:
            
                ; Player ataca y se introduce el cooldown
                ld a, #player_cooldown_attack
                ld (player_cooldown_attack_cont), a
                call player_attack
                
                ld a, #2
                ld (redrawcounter), a
                
                ld a, #1 ;; estado sprite atacar
                ld (sprite_status), a
                
                ld a, #0 ;; Esto fuerza a que comienza un nuevo sprite en caso de que hubiese uno con contador activo
                ld (sprite_cont), a
                
                ret
                
    player_no_puede_atacar:
        ld (player_cooldown_attack_cont), a

    dejar_de_comprobar_ataque:

;;========Movimiento horizontal==========

	;;Comprueba si la tecla D esta pulsada
	ld hl, #Key_D						;;Como es una constante pilla el valor de la letra D
    call cpct_isKeyPressed_asm
    cp  #0   
    jr nz, d_pressed	
    
    ld hl, #Joy0_Right
    call cpct_isKeyPressed_asm
    cp  #0   
    jr nz, d_pressed
    
    jp d_not_pressed
    
        d_pressed:
        ;;D esta pulsada
        call move_hero_right
    	  
        ld a, #2 ;; estado sprite walk
        ld (sprite_status), a
    
    d_not_pressed:
    
	;;Comprueba si la tecla A esta pulsada
    ld hl, #Key_A							;;Como es una constante pilla el valor de la letra A
    call cpct_isKeyPressed_asm
    cp  #0                            		;;Comprueba si a==0
    jr nz, a_pressed					;;Salta si A==0 (A no pulsada)
    
    ld hl, #Joy0_Left							
    call cpct_isKeyPressed_asm
    cp  #0                            	
    jr nz, a_pressed				
    
    jp a_not_pressed
    
        a_pressed:

    	;;A pulsada
    	call move_hero_left
    
        ld a, #2 ;; estado sprite walk
        ld (sprite_status), a

    a_not_pressed:

;;========Movimiento vertical ==========

    ;;Comprueba si la tecla WE esta pulsada
    ld hl, #Key_W							;;Como es una constante pilla el valor de la letra A
    call cpct_isKeyPressed_asm
    cp  #0                            		;;Comprueba si a==0
    jr nz, w_pressed						;;Salta si A==0 (A no pulsada)
    
    ld hl, #Joy0_Up							
    call cpct_isKeyPressed_asm
    cp  #0                            	
    jr nz, w_pressed					
    
    jp w_not_pressed
    
        w_pressed:
    	;;W pulsada
    	call move_hero_up
    	
    	ld a, #2 ;; estado sprite walk
        ld (sprite_status), a

    w_not_pressed:
    
    ;;Comprueba si la tecla S esta pulsada
    ld hl, #Key_S						;;Como es una constante pilla el valor de la letra A
    call cpct_isKeyPressed_asm
    cp  #0                            		;;Comprueba si a==0
    jr nz, s_pressed						;;Salta si A==0 (A no pulsada)
    
    ld hl, #Joy0_Down					
    call cpct_isKeyPressed_asm
    cp  #0                            	
    jr nz, s_pressed
    
    jp s_not_pressed
        
        s_pressed:
    	;;A pulsada
    	call move_hero_down
    	
    	ld a, #2 ;; estado sprite walk
        ld (sprite_status), a

    s_not_pressed:
    
    ;;Comprueba si NO hay ninguna tecla pulsada, y solo si no esta en estado Attack

    call cpct_isAnyKeyPressed_asm
    cp #0
    jp nz, hay_alguna_tecla_pulsada
        ; Ninguna tecla pulsada
        
        ld a, (sprite_status)
        cp #1
        jp z, hay_alguna_tecla_pulsada ;; en estado attack no se pone en iddle

            ld a, #0 ;; estado sprite idle
            ld (sprite_status), a
            
            ld a, #1 ;; estado walk
            ld (sprite_status_walk), a
        
    hay_alguna_tecla_pulsada:

ret

;;=============================================================================================
;; DIBUJAR
;; INPUTS: IX = player struct pointer, a = COLOR
;; DESTROY: AF, BC, DE, HL
;;=============================================================================================

drawPlayer: 

	;;Calculate Screen Position
	ld c, player_x_pos_off(ix)				;; C=Obsx
	ld b, player_y_pos_off(ix) 				;; B=Obsy
	call cpct_getScreenPtr_asm

	;;	Draw a box
	ex de, hl ;;intercambiar los valores
	ld   h, player_sprite_off + 1(ix)   ;; | HL = Pointer to Player Sprite
    ld   l, player_sprite_off + 0(ix)   ;; |
	ld c, player_width_off(ix)
	ld b, player_height_off(ix)
	
	call cpct_drawSpriteMasked_asm
ret

;;===============================
;; Zona de funciones DIBUJAR LA PUNTUACION
;; INPUTS: A => COLOR 
;; DESTROY: A, B, C, DE, HL
;; OUTPUT: 
;;===============================

drawScore::
	ld  a, (text_counter)
	cp #0
	ret z

	dibuja_texto_score:
	call get_screen_pointer
	ex de, hl

	dibuja_millar_score:
	ld a, (hero_score_sup)		;Carga en A hero_score
	rr a				;|
	rr a				;|
	rr a				;|
	rr a				;|Mueve 4 posiciones a la derecha los bits de hero_score
	ld b, #0x0F			;Carga en B 00001111
	and b				;Se queda con los 4 bits primeros de hero_score en A (que se han desplazado al final)
	call convert_to_ASCII		;Convierte en ASCII el millar de hero_score

	push af 			;Se salva el valor de a (hero_score)

	ld a, #0x18
	add a, e
	ld e, a 			;Se aumenta en 0x18 el valor de DE (puntero de dirección de dibujado)

	pop af 				;Se recupera el valor de a (hero_score)
	push de 			;Se guarda el valor de de (dirección memoria)

	;Dibuja el texto en la posicion a la que apunta de
	ld c, #0x03			;Dibuja el texto en color 0x07
	ld b, #10			;Dibuja el texto obre fondo de color 0x00
	call cpct_drawCharM0_asm	;Funcion de CPCTELERA que dibuja un caracter (millar de hero_score)

	dibuja_centena_score:
	ld a, (hero_score_sup)		;Carga en A hero_score
	ld b, #0x0F			;Carga en B 00001111
	and b				;Se queda con los 4 bits finales de hero_score en A
	call convert_to_ASCII		;Convierte en ASCII la centena de hero_score

	pop de 				;Se recupera el valor de de (direccion de memoria)
	push af 			;Se salva el valor de a (hero_score)

	ld a, #0x4
	add a, e
	ld e, a 			;Se aumenta en 0x04 el valor de DE (puntero de dirección de dibujado)

	pop af 				;Se recupera el valor de a (hero_score)
	push de 			;Se guarda el valor de de (dirección memoria)

	;Dibuja el texto en la posicion a la que apunta de
	ld c, #0x03		;Dibuja el texto en color 0x07
	ld b, #10		;Dibuja el texto obre fondo de color 0x00
	call cpct_drawCharM0_asm	;Funcion de CPCTELERA que dibuja un caracter (centena de hero_score)

	dibuja_decena_score:
	ld a, (hero_score)		;Carga en A hero_score
	rr a				;|
	rr a				;|
	rr a				;|
	rr a				;|Mueve 4 posiciones a la derecha los bits de hero_score
	ld b, #0x0F			;Carga en B 00001111
	and b				;Se queda con los 4 bits primeros de hero_score en A (que se han desplazado al final)
	call convert_to_ASCII		;Convierte en ASCII la decena de hero_score

	pop de 				;Se recupera el valor de de (direccion de memoria)
	push af 			;Se salva el valor de a (hero_score)

	ld a, #0x04
	add a, e
	ld e, a 			;Se aumenta en 0x04 el valor de DE (puntero de dirección de dibujado)

	pop af 				;Se recupera el valor de a (hero_score)
	push de 			;Se guarda el valor de de (dirección memoria)

	;Dibuja el texto en la posicion a la que apunta de
	ld c, #0x03			;Dibuja el texto en color 0x07
	ld b, #10			;Dibuja el texto obre fondo de color 0x00
	call cpct_drawCharM0_asm	;Funcion de CPCTELERA que dibuja un caracter (decena de hero_score)

	dibuja_unidad_score:
	ld a, (hero_score)		;Carga en A hero_score
	ld b, #0x0F			;Carga en B 00001111
	and b				;Se queda con los 4 bits finales de hero_score en A
	call convert_to_ASCII		;Convierte en ASCII la unidad de hero_score

	pop de 				;Se recupera el valor de de (direccion de memoria)
	push af 			;Se salva el valor de a (hero_score)

	ld a, #0x04
	add a, e
	ld e, a 			;Se aumenta en 0x04 el valor de DE (puntero de dirección de dibujado)

	pop af 				;Se recupera el valor de a (hero_score)

	;Dibuja el texto en la posicion a la que apunta de
	ld c, #0x03			;Dibuja el texto en color 0x07
	ld b, #10		;Dibuja el texto obre fondo de color 0x00
	call cpct_drawCharM0_asm	;Funcion de CPCTELERA que dibuja un caracter (unidad de hero_score)
	

	ld a, (text_counter)
	dec a 
	ld (text_counter), a
ret

;===============================
;; Zona de funciones AUMENTAR LA PUNTUACION
;; INPUTS: A  => PUNTUACION A AUMENTAR
;;	   HL => DIRECCION DE LA PUNTUACION A AUMENTAR
;; DESTROY: A, B, C, HL
;; OUTPUT: GUARDA EN hero_score LA NUEVA PUNTUACION
;;===============================

increase_score:
	ld b, a 			;Carga en B la puntuacion a aumentar
	ld a, (hl)			;Carga en A la hero_score
	bucle_score:			;|
		inc a			;|
		dec b			;|
	jr nz, bucle_score		;Bucle que aumenta la puntuacion

	ld c, a				;Salva en C la puntuacion

	ld b, #0x0F			;Carga en B 00001111
	and b				;Se queda con los 4 ultimos bits (la unidad)
	cp #0x0A			;Comprueba si ha pasado de 09 a 0A (en A hay un 0A)
	jr nz, guarda_new_score		;En caso afirmativo pasa a bucle_score_decena, en caso negativo guarda la score

	ld b, #6			;Carga en B la puntuacion a aumentar
	bucle_score_decena:		;|
		inc c			;|

		ld a, c
		cp #0xA0			
		jr nz, continua_bucle_score_decena
			push hl
			ld a, #1
			ld hl, #hero_score_sup
			call increase_score
			pop hl
			ld c, #0x00
			jr guarda_new_score
		continua_bucle_score_decena:
		dec b			;|
	jr nz, bucle_score_decena	;Bucle que aumenta la puntuacion de A a 0, aumentando la decena		

	guarda_new_score:
	ld a, c				;|
	ld (hl), a		;Guarda en hero_score la nueva puntuacion

	;;Marca que debe redibujar
	ld a, #2
	ld (text_counter), a
	
	ld a, (hero_score_rondas)
	inc a
	ld (hero_score_rondas), a
ret

health_counter_call::
	ld a, #2
	ld (health_counter), a
ret

;;===============================
;; Zona de funciones de CONVERTIR A ASCII
;; INPUTS: A => NUMERO (0-9) 
;; DESTROY: A, B
;; OUTPUT: A => NUMERO (0-9) EN ASCII
;;===============================

convert_to_ASCII:
	ld b, #0x30			;Carga en B 0x30
	bucle_ascii:			;|
		inc a			;|
		dec b			;|
	jr nz, bucle_ascii		;Aumenta el numero en 0x30, que es su codigo en ASCII
ret

drawHealth::

	ld  a, (health_counter)
	cp #0
	ret z
	
    call get_screen_pointer

    call hero_getPtrIX 
    ld a, player_life_off(ix)
    call convert_to_ASCII      

    ld de, #0x079C
    add hl, de
    ex de, hl

    ld c, #0x03
    ld b, #10
    call cpct_drawCharM0_asm
    
	ld a, (health_counter)
	dec a 
	ld (health_counter), a
ret


drawMaxScore::
    call get_screen_pointer

    ld de, #0x07A4
    add hl, de
    ex de, hl

    ld a, (max_score_sup)      ;Carga en A hero_score
    rr a                ;|
    rr a                ;|
    rr a                ;|
    rr a                ;|Mueve 4 posiciones a la derecha los bits de hero_score
    ld b, #0x0F         ;Carga en B 00001111
    and b               ;Se queda con los 4 bits primeros de hero_score en A (que se han desplazado al final)
    call convert_to_ASCII       ;Convierte en ASCII el millar de hero_score

    push af             ;Se salva el valor de a (hero_score)

    ld a, #0x18
    add a, e
    ld e, a             ;Se aumenta en 0x18 el valor de DE (puntero de dirección de dibujado)

    pop af              ;Se recupera el valor de a (hero_score)
    push de             ;Se guarda el valor de de (dirección memoria)

    ;Dibuja el texto en la posicion a la que apunta de
    ld c, #0x03         ;Dibuja el texto en color 0x07
    ld b, #10           ;Dibuja el texto obre fondo de color 0x00
    call cpct_drawCharM0_asm    ;Funcion de CPCTELERA que dibuja un caracter (millar de hero_score)

    ld a, (max_score_sup)      ;Carga en A hero_score
    ld b, #0x0F         ;Carga en B 00001111
    and b               ;Se queda con los 4 bits finales de hero_score en A
    call convert_to_ASCII       ;Convierte en ASCII la centena de hero_score

    pop de              ;Se recupera el valor de de (direccion de memoria)
    push af             ;Se salva el valor de a (hero_score)

    ld a, #0x4
    add a, e
    ld e, a             ;Se aumenta en 0x04 el valor de DE (puntero de dirección de dibujado)

    pop af              ;Se recupera el valor de a (hero_score)
    push de             ;Se guarda el valor de de (dirección memoria)

    ;Dibuja el texto en la posicion a la que apunta de
    ld c, #0x03     ;Dibuja el texto en color 0x07
    ld b, #10       ;Dibuja el texto obre fondo de color 0x00
    call cpct_drawCharM0_asm    ;Funcion de CPCTELERA que dibuja un caracter (centena de hero_score)

    ld a, (max_score)      ;Carga en A hero_score
    rr a                ;|
    rr a                ;|
    rr a                ;|
    rr a                ;|Mueve 4 posiciones a la derecha los bits de hero_score
    ld b, #0x0F         ;Carga en B 00001111
    and b               ;Se queda con los 4 bits primeros de hero_score en A (que se han desplazado al final)
    call convert_to_ASCII       ;Convierte en ASCII la decena de hero_score

    pop de              ;Se recupera el valor de de (direccion de memoria)
    push af             ;Se salva el valor de a (hero_score)

    ld a, #0x04
    add a, e
    ld e, a             ;Se aumenta en 0x04 el valor de DE (puntero de dirección de dibujado)

    pop af              ;Se recupera el valor de a (hero_score)
    push de             ;Se guarda el valor de de (dirección memoria)

    ;Dibuja el texto en la posicion a la que apunta de
    ld c, #0x03         ;Dibuja el texto en color 0x07
    ld b, #10           ;Dibuja el texto obre fondo de color 0x00
    call cpct_drawCharM0_asm    ;Funcion de CPCTELERA que dibuja un caracter (decena de hero_score)

    ld a, (max_score)      ;Carga en A hero_score
    ld b, #0x0F         ;Carga en B 00001111
    and b               ;Se queda con los 4 bits finales de hero_score en A
    call convert_to_ASCII       ;Convierte en ASCII la unidad de hero_score

    pop de              ;Se recupera el valor de de (direccion de memoria)
    push af             ;Se salva el valor de a (hero_score)

    ld a, #0x04
    add a, e
    ld e, a             ;Se aumenta en 0x04 el valor de DE (puntero de dirección de dibujado)

    pop af              ;Se recupera el valor de a (hero_score)

    ;Dibuja el texto en la posicion a la que apunta de
    ld c, #0x03         ;Dibuja el texto en color 0x07
    ld b, #10       ;Dibuja el texto obre fondo de color 0x00
    call cpct_drawCharM0_asm    ;Funcion de CPCTELERA que dibuja un caracter (unidad de hero_score)
    
ret

Draw_death::

    ld de, #0x8000
    ld c, #0             ;; C=Obsx
    ld b, #86            ;; B=Obsy
    call cpct_getScreenPtr_asm
    ex de, hl

    ld   hl, #end_game  ;; HL = Pointer to the start of the string
   ; ld   de, #0xC280  ;; DE = Pointer to video memory location where the string will be drawn
    ld   bc, #0x0F07  ;; B = Background colour, C = Foreground colour
    call cpct_drawStringM0_asm ;; Call the string drawing function


    ld de, #0xC000
    ld c, #0             ;; C=Obsx
    ld b, #86           ;; B=Obsy
    call cpct_getScreenPtr_asm
    ex de, hl

    ld   hl, #end_game  ;; HL = Pointer to the start of the string
  ;  ld   de, #0xC280  ;; DE = Pointer to video memory location where the string will be drawn
    ld   bc, #0x0F07  ;; B = Background colour, C = Foreground colour
    call cpct_drawStringM0_asm ;; Call the string drawing function
ret

CheckUserInputRestart::
call cpct_scanKeyboard_asm 
    ld hl, #Key_R                           ;;Como es una constante pilla el valor de la letra A

    call cpct_isKeyPressed_asm
ret

put_mute::
    call cpct_scanKeyboard_asm 
    ld hl, #Key_M                           ;;Como es una constante pilla el valor de la letra A
    call cpct_isKeyPressed_asm
ret
